

import java.awt.*;
import java.applet.Applet;
import netscape.javascript.JSObject;
import webwisdom.tango.*;


public class Chat extends Applet implements TDataListener
{
    private static final String CL="Chat";


    TextField text;

    private TAgent agent=null;
    private int channelId=0;


    public void init()
    {
      super.init();
      setLayout(new BorderLayout());
      text=new TextField("Uninitialized");
      add("North",text);
      System.out.println(CL+".init().");


      JSObject jsWin=JSObject.getWindow(this);
      Object[] args=new Object[1];
      args[0]=this;
      jsWin.call("appletReadyJ",args);
    }// init _______________________________________________________________


    public void initTangoJS(TAgent a,Number ch)
    {
      agent=a;
      channelId=((Number)ch).intValue();
      System.out.println(CL+".initTangoJS(): agent="+agent+
			 ",channel="+channelId);
      if(agent!=null)
	agent.addTDataListener(channelId,this);
      //System.out.println(CL+".initTango(): isMa="+agent.isMaster());
    }// initTangoJS ________________________________________________________


    public boolean handleEvent(Event evt)
    {
      if(evt.id==Event.ACTION_EVENT)
      {
	if(evt.target==text)
	{
	  if(agent!=null)
	    agent.send(channelId,stringToBytes(text.getText()));
	}
      }
      return super.handleEvent(evt);
    }// handleEvent ________________________________________________________


    public void receive(byte[] b)
    {
      System.out.println(CL+".receive(byte["+b.length+"])");
      text.setText(bytesToString(b));
    }// receive ____________________________________________________________


    private String bytesToString(byte t[])
    {
      return new String(t,0);
    }// bytesToString ______________________________________________________


    private byte[] stringToBytes(String s)
    {
      int l=s.length();
      byte[] t=new byte[l];
      s.getBytes(0,l,t,0);
      return t;
    }// stringToBytes ______________________________________________________


    public String toString()
    {
      return CL+"["+this.hashCode()+"]";
    }// toString ___________________________________________________________


}// Chat ///////////////////////////////////////////////////////////////////
